/* The C procedures for the Transf code
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "main_tcl.h"
#include "plain_c.h"
/*
  Function to make computations
*/
int ET_COMMAND_mifreg(ET_TCLARGS){
  extern char *tab_msg[],*mif_msg[];
  char s[MAXSTR],coord_sys[MAXSTR],*sptr;
  char tab_nam[MAXSTR],mifi_nam[MAXSTR],mifo_nam[MAXSTR];
  char log_nam[MAXSTR],midi_nam[MAXSTR],mido_nam[MAXSTR];
  double p[8];
  int k,et;
  FILE *tab_fp,*mifi_fp,*mifo_fp,*midi_fp,*mido_fp,*log_fp;

  strcpy(s,".calc.in.tab_ent");
  if(Et_EvalF(interp,"%s get",s)!=TCL_OK){
    Et_ResultF(interp,"Cannot read from \"%q\" entry widget",s);
    return TCL_ERROR;
  }
  strcpy(tab_nam,interp->result);
  if((tab_fp=fopen(tab_nam,"r"))==NULL){
    Et_ResultF(interp,"Cannot open \"%q\"",tab_nam);
    return TCL_ERROR;
  }
  strcpy(s,".calc.in.mii_ent");
  if(Et_EvalF(interp, "%s get",s)!=TCL_OK){
    Et_ResultF(interp,"Cannot read from \"%q\" entry widget",s);
    fclose(tab_fp);
    return TCL_ERROR;
  }
  strcpy(mifi_nam,interp->result);
  if((mifi_fp=fopen(mifi_nam,"r"))==NULL){
    Et_ResultF(interp,"Cannot open \"%q\"",mifi_nam);
    fclose(tab_fp);
    return TCL_ERROR;
  }
  strcpy(s,".calc.in.mio_ent");
  if(Et_EvalF(interp, "%s get",s)!=TCL_OK){
    Et_ResultF(interp,"Cannot read from \"%q\" entry widget",s);
    fclose(tab_fp);
    fclose(mifi_fp);
    return TCL_ERROR;
  }
  strcpy(mifo_nam,interp->result);
  if((mifo_fp=fopen(mifo_nam,"w"))==NULL){
    Et_ResultF(interp,"Cannot create \"%q\"",mifo_nam);
    fclose(tab_fp);
    fclose(mifi_fp);
    return TCL_ERROR;
  }
  strcpy(midi_nam,mifi_nam);
  sptr=strrchr(midi_nam,'.');
  strcpy(sptr,".mid");
  if((midi_fp=fopen(midi_nam,"r"))==NULL){
    mido_fp=NULL;
  } else {
    strcpy(mido_nam,mifo_nam);
    sptr=strrchr(mido_nam,'.');
    strcpy(sptr,".mid");
    mido_fp=fopen(mido_nam,"w");
  }
  strcpy(log_nam,tab_nam);
  sptr=strrchr(log_nam,'.');
  strcpy(sptr,".log");
  if((log_fp=fopen(log_nam,"w"))==NULL){
    Et_ResultF(interp,"Cannot create \"%q\"",log_nam);
    fclose(tab_fp);
    fclose(mifi_fp);
    fclose(mifo_fp);
    fclose(midi_fp);
    fclose(mido_fp);
    return TCL_ERROR;
  }

  et=atoi(argv[1]);

  fprintf(log_fp,"Raster coordinate registration:\n%s\n\n",tab_nam);

  if((k=read_tab_calc_tr_parm(tab_fp,log_fp,coord_sys,p))!=0){
    Et_ResultF(interp,"error reading \"%q\": %q",tab_nam,tab_msg[k-1]);
    fclose(tab_fp);
    fclose(mifi_fp);
    fclose(mifo_fp);
    fclose(midi_fp);
    fclose(mido_fp);
    fclose(log_fp);
    return TCL_ERROR;
  }

  if((k=mif_trans_mif(mifi_fp,mifo_fp,midi_fp,mido_fp,coord_sys,p,et))!=0){
    Et_ResultF(interp,"error reading \"%q\": %q",mifi_nam,mif_msg[k-1]);
    fclose(tab_fp);
    fclose(mifi_fp);
    fclose(mifo_fp);
    fclose(midi_fp);
    fclose(mido_fp);
    fclose(log_fp);
    return TCL_ERROR;
  }

  fclose(tab_fp);
  fclose(mifi_fp);
  fclose(mifo_fp);
  fclose(midi_fp);
  fclose(mido_fp);
  fclose(log_fp);

  Et_ResultF(interp,"Success: %q\nconverted to %q,\nlog written to %q",mifi_nam,mifo_nam,log_nam);
  return TCL_OK;
}
